unit UActionCompareView;

{ EOFile by YT }

interface

uses
	Windows, SysUtils,
	SysUtilsW, SysHacks, AlgUtils,
	LConsts, LWindows, LActions, LCmmDlgs, LAddDlgs, LStdCtls,
	EOFileIntf, UPath, UView, UFolders;

type
	TCompareViewAction = class(T0Action)
	protected
		procedure DoExecute; override;
	public
		constructor Create;
		procedure Update; override;
	end;

implementation

{ TCompareViewAction }

constructor TCompareViewAction.Create;
begin
	inherited Create(False);
	SetName('CompareView');
	SetText('tH_r...');
	SetHint('ӂ̃r[rʂ̃t@CI܂');
end;

procedure TCompareViewAction.DoExecute;

	type TCompareMode = (cmNotExist, cmNewer, cmExist, cmOlder);
	const CompareModeText: array[TCompareMode] of WideString = (
		'', 'V', '', 'Â');
	var View: TFilerView;

	function SelectFolder(const Title: WideString; out Mode: TCompareMode): TFilerView;

		var Dialog: TSelectDialog;
		var DialogModes: array[TCompareMode] of TRadioButton;
		var Context: Pointer;

		function AddViewNotCurrent(V: TFilerView): Boolean; cdecl;
		var
			Item: T0ControlItem;
		begin
			if V <> View then
			begin
				Item := Dialog.Add;
				Item.Data := V;
				Item.Text := V.Model.DisplayText;
			end;
			Result := False;
		end;

	var
		R: TRect;
		S: TSize;
		CY: Integer;
		I: TCompareMode;
	begin
		Context := GetContext;

		Dialog := TSelectDialog.Create(View.HostWindow, Title);
		Dialog.Owner := Garbage;

		View.HostWindow.EnumerateViews(CEachFilerView(@AddViewNotCurrent), Context);

		for I := Low(DialogModes) to High(DialogModes) do
			DialogModes[I] := TRadioButton.Create(Dialog, CompareModeText[I], ZeroPoint, DefaultSize);

		S := DialogModes[Low(DialogModes)].BoundsSize;
		CY := S.CY;
		S.cx := 80;
		S.cy := CY * Length(DialogModes);
		Dialog.SpaceSize := S;

		R := Dialog.SpaceRect;
		for I := Low(DialogModes) to High(DialogModes) do
		begin
			DialogModes[I].SetBounds(R.Left, R.Top, 1000, CY);
			Inc(R.Top, CY);
		end;

		DialogModes[Low(DialogModes)].Checked := True;

		Result := nil;
		if Dialog.Execute then
		begin
			Result := Dialog.Selected.Data;
			for I := Low(DialogModes) to High(DialogModes) do
				if DialogModes[I].Checked then Mode := I;
		end;
	end;

var
	TargetView: TFilerView;
	Mode: TCompareMode;
	I, J: Integer;
	P, Q: PFile;
	S: Boolean;
begin
	View := ActiveView;
	TargetView := SelectFolder('tH_r', Mode);
	if TargetView <> nil then
	begin
		case Mode of
		cmNotExist:
			for I := View.ItemCount - 1 downto 0 do
			begin
				S := True;
				P := View.Items[I];
				for J := TargetView.ItemCount - 1 downto 0 do
				begin
					Q := TargetView.Items[J];
					if CompareFileName(Q.Name, Q.NameLength, P.Name, P.NameLength) = 0 then
					begin
						S := False;
						Break;
					end;
				end;
				View.Selected[I] := S
			end;
		cmNewer:
			for I := View.ItemCount - 1 downto 0 do
			begin
				S := True;
				P := View.Items[I];
				for J := TargetView.ItemCount - 1 downto 0 do
				begin
					Q := TargetView.Items[J];
					if (CompareFileName(Q.Name, Q.NameLength, P.Name, P.NameLength) = 0) and
						(CompareFileTime(Q.LastWriteTime, P.LastWriteTime) >= 0) then
					begin
						S := False;
						Break;
					end;
				end;
				View.Selected[I] := S
			end;
		cmExist:
			for I := View.ItemCount - 1 downto 0 do
			begin
				S := False;
				P := View.Items[I];
				for J := TargetView.ItemCount - 1 downto 0 do
				begin
					Q := TargetView.Items[J];
					if CompareFileName(Q.Name, Q.NameLength, P.Name, P.NameLength) = 0 then
					begin
						S := True;
						Break;
					end;
				end;
				View.Selected[I] := S
			end;
		cmOlder:
			for I := View.ItemCount - 1 downto 0 do
			begin
				S := False;
				P := View.Items[I];
				for J := TargetView.ItemCount - 1 downto 0 do
				begin
					Q := TargetView.Items[J];
					if (CompareFileName(Q.Name, Q.NameLength, P.Name, P.NameLength) = 0) and
						(CompareFileTime(Q.LastWriteTime, P.LastWriteTime) > 0) then
					begin
						S := True;
						Break;
					end;
				end;
				View.Selected[I] := S
			end;
		end;
	end
end;

procedure TCompareViewAction.Update;
begin
	SetEnabled(ActiveView.HostWindow.ViewCount >= 2);
end;

end.

