unit UView;

{ EOFile by YT }

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
	Windows, Messages, ActiveX, ShlObj, Types, SysUtils, CommCtrl,
	SysUtilsW, SysHacks, AlgUtils, WinTips, ShlTips,
	LConsts, LObjects, LActions, LGraphics,
	LWindows, LStdCtls, LCmmCtls, LAddCtls, LCmmDlgs, LAddDlgs, LMenus, LMenusXP,
	EOFileIntf, UPath, UFolders, UFileOp;

const
	HTINFOSPACE = 100;
	FilerWindowClassName = 'YT_EOFile_Window_2';
	WM_APP_REALIGN    = WM_APP +  1;
	WM_APP_SETFOCUS   = WM_APP +  2;
	WM_APP_UPDATESKIN = WM_APP + 11;
	WM_APP_OPENVIEW   = WM_APP + 12;
	WM_APP_CLOSEVIEW  = WM_APP + 13;
	CmdLineMagicNumber = DWORD($E0E0E0E0);

type
	TFilerWindow = class;

	TSortMode = (smNone, smNameMix, smNameMixR,
					smName, smNameR, smFileExt, smFileExtR,
					smSize, smSizeR, smWrite, smWriteR, smAccess, smAccessR);

	PSkinTemplate = ^TSkinTemplate;
	TSkinTemplate = record
		OwnerDraw: Boolean;
		FlatScrollBar: Boolean;
		ShortFileName: Boolean;
		Background: WideString;
		Info: WideString;
		NameSpace: WideString;
		Founds: WideString;
		Archive: WideString;
		FaceName: WideString;
		BackgroundColor: COLORREF; {Background = 0 ̎̂}
		FileName: COLORREF;
		SystemFile: COLORREF;
		Hidden: COLORREF;
		ReadOnly: COLORREF;
		Directory: COLORREF;
		Virtual: COLORREF;
		Selected: COLORREF;
		Line: COLORREF; {̐F}
	case Integer of
	0: (InfoTexts: array[Boolean] of COLORREF);
	1: (InfoText, SelectedInfoText: COLORREF);
	end;

	TSkin = record
		Background: HBITMAP;
		Info: HBITMAP;
		NameSpace: HBITMAP;
		Founds: HBITMAP;
		Archive: HBITMAP;
		Symbol: HBITMAP;
		BackgroundColor: COLORREF; {Background = 0 ̎̂}
		FileName: COLORREF;
		SystemFile: COLORREF;
		Hidden: COLORREF;
		ReadOnly: COLORREF;
		Directory: COLORREF;
		Virtual: COLORREF;
		Selected: COLORREF;
		Line: COLORREF; {̐F}
	case Integer of
	0: (InfoTexts: array[Boolean] of COLORREF);
	1: (InfoText, SelectedInfoText: COLORREF);
	end;

	TFilerView = class(TLightListBox, IObserver, IView, IDropTarget, IDropSource)
	private
		FSkin: TSkin;
		FFontSize: TSize;
		FMouseDownPos: TPoint;
		FFaceFont: TFont;
		FItems: TFilePtrArray;
		FPredView: TFilerView;
		FSuccView: TFilerView;
		FModel: IFolder;
		FWildCard: PWildCardExpression;
		FInfoHeight: Integer;
		FPen: TPen;
		FContextMenu: IContextMenu;
		FUpdating: Integer;
		FSortMode: TSortMode;
		FDragDropping: Boolean;
		FDragDropAccepting: Boolean;
		FRightDragging: Boolean;
		procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
		procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
		procedure WMNCPaint(var Message: TWMNCPaint); message WM_NCPAINT;
		procedure WMInitMenuPopup(var Message: TWMInitMenuPopup); message WM_INITMENUPOPUP;
		procedure WMMeasureItem(var Message: TWMMeasureItem); message WM_MEASUREITEM;
		procedure WMDrawItem(var Message: TWMDrawItem); message WM_DRAWITEM;
		procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
		procedure WMRButtonDown(var Message: TWMRButtonDown); message WM_RBUTTONDOWN;
		procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
		procedure WMMButtonUp(var Message: TWMMButtonUp); message WM_MBUTTONUP;
		procedure WMContextMenu(var Message: TWMContextMenu); message WM_CONTEXTMENU;
		procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
		procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
		procedure WMLightWindows(var Message: TMessage); message WM_LIGHTWINDOWS;
		procedure WMAppUpdateSkin(var Message); message WM_APP_UPDATESKIN;
		procedure WMAppOpenView(var Message: TMessage); message WM_APP_OPENVIEW;
		procedure WMAppCloseView(var Message: TMessage); message WM_APP_CLOSEVIEW;
		function GetWildCard: WideString;
		procedure SetWildCard(const Value: WideString);
		procedure SetModel(const Value: IFolder);
		procedure SetSortMode(const Value: TSortMode);
		function GetItems(Index: Integer): PFile;
		{IObserver}
		procedure ModelUpdate;
		procedure IObserver.Observe = ModelUpdate;
		{IView}
		function GetModel: IFolder;
		procedure IView.FocusTo = FocusTo;
		function GetViewSelectedOfViewItem(AIndex: Integer): Boolean;
		function IView.GetSelected = GetViewSelectedOfViewItem;
		function GetCountOfViewItem: Integer;
		function IView.GetCount = GetCountOfViewItem;
		function GetSelectedCountOfViewItem: Integer;
		function IView.GetSelectedCount = GetSelectedCountOfViewItem;
		procedure IView.SetFocus = SetFocus;
		procedure IView.Close = CloseOnDelay;
		{IDropTarget}
		function DragEnter(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HResult; stdcall;
		function DragOver(grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HResult; stdcall;
		function DragLeave: HResult; stdcall;
		function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HResult; stdcall;
		{IDropSource}
		function QueryContinueDrag(fEscapePressed: BOOL; grfKeyState: Longint): HResult; stdcall;
		function GiveFeedback(dwEffect: Longint): HResult; stdcall;
	protected
		procedure Initialize; override;
		procedure Finalize; override;
		procedure FontChanged; override;
		procedure DrawItem(Index: Integer; DC: HDC; const Rect: TRect); override;
		procedure ViewUpdate(Replace: Boolean);
		function CanSelectItem(Index: Integer): Boolean; override;
		procedure DoSelectItem(Index: Integer; Value: Boolean); override;
		function KeyDown(ShiftState: TShiftKeys; Code: Byte): Boolean; override;
		function ProcessContextMenu(var Message: TMessage): Boolean;
	public
		constructor Create(AParent: TFilerWindow; Next: TFilerView; const AModel: IFolder);
		function HostWindow: TFilerWindow;
		procedure FocusTo(const AName: WideString);
		procedure FocusNear(const AName: WideString);
		procedure FocusNearWithDisplayName(const AName: WideString);
		function FocusedFile: PFile;
		function SelectedFiles: TFilePtrArray;
		function SelectedIsRealFiles: Boolean;
		function QueryContextMenu: IContextMenu;
		procedure BeginUpdate;
		procedure EndUpdate;
		procedure AcceptDataObject(const DataObject: IDataObject; Effect: DWORD);
		procedure CloseOnDelay;
		property Items[Index: Integer]: PFile read GetItems;
		property SortMode: TSortMode read FSortMode write SetSortMode;
		property WildCard: WideString read GetWildCard write SetWildCard;
		property Model: IFolder read FModel write SetModel;
		property SuccView: TFilerView read FSuccView;
	end;

	CEachFilerView = function(View: TFilerView; Context: Pointer): Boolean cdecl;

	TFilerWindow = class(T0MainWindow, IKeyManager)
	private
		FFirstPath: PPath;
		FFirstView: TFilerView;
		FLastView: TFilerView;
		FViewCount: Integer;
		FActiveView: TFilerView;
		FStatusBar: TStatusBar;
		FSpaceStatus: TStatusPane;
		FViewsStatus: TStatusPane;
		FKeyManager: TKeyAssignment;
		procedure WMAppRealign(var Message); message WM_APP_REALIGN;
		procedure WMAppSetFocus(var Message: TMessage); message WM_APP_SETFOCUS;
		procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
		procedure WMGetMinMaxInfo(var Message: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
		procedure WMSize(var Message: TWMSize); message WM_SIZE;
		procedure WMDrawItem(var Message: TWMDrawItem); message WM_DRAWITEM;
		procedure WMMeasureItem(var Message: TWMMeasureItem); message WM_MEASUREITEM;
		procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
		procedure WMCopyData(var Message: TWMCopyData); message WM_COPYDATA;
		function GetKeyManager: IKeyManager;
	protected
		class function WindowClassName: string; override;
		procedure Initialize; override;
		procedure Finalize; override;
		procedure UpdateStatusBar;
		procedure FocusChanged; override;
		function ReadyHint: WideString; override;
	public
		constructor Create(FirstPath: PPath);
		procedure Realign; override;
		function EnumerateViews(Proc: CEachFilerView; Context: Pointer): TFilerView; overload;
		function EnumerateViews(Proc: CEachView; Context: Pointer): IView; overload;
		procedure Update; override;
		property ViewCount: Integer read FViewCount;
		property ActiveView: TFilerView read FActiveView;
		property KeyManager: IKeyManager read GetKeyManager implements IKeyManager;
		property KeyAssignment: TKeyAssignment read FKeyManager;
	end;

	CEachFilerWindow = function(View: TFilerWindow; Context: Pointer): Boolean cdecl;

function EnumerateFilerWindows(Proc: CEachFilerWindow; Context: Pointer): TFilerWindow;
function FilerWindowCount: Integer;
function ActiveView: TFilerView;
function SelectFolder(const Title: WideString; out Path: TPath): Boolean;
procedure OpenView(Current: TFilerView; const NewPath: TPath);

const
	HDropFormat: FORMATETC = (cfFormat: CF_HDROP; ptd: nil;
					dwAspect: DVASPECT_CONTENT; lindex: -1; tymed: TYMED_HGLOBAL);

var
	ApplicationSkinTemplate: PSkinTemplate;

implementation

uses
	UMain;

var
	_FilerWindowCount: Integer;

procedure OpenView(Current: TFilerView; const NewPath: TPath);
var
	W: Integer;
	Folder: IFolder;
	Host: TFilerWindow;
	R, WorkArea: TRect;
	View: TFilerView;
begin
	Application.BeginWrite;
	try
		Folder := (Application as IFolderManager).GetFolder(NewPath);
		Host := Current.HostWindow;
		View := TFilerView.Create(Host, Current.SuccView, Folder);
		View.SetFocus;

		WorkArea := SystemWorkArea;
		W := Host.ViewCount * View.BoundsSize.cx + GetSystemMetrics(SM_CXSIZEFRAME) * 2;
		if (WorkArea.Right - WorkArea.Left) > W then
		begin
			Host.BoundsSize := Size(W, Host.BoundsSize.CY);
			R := Host.BoundsRect;
			if R.Right > WorkArea.Right then
			begin
				OffsetRect(R, WorkArea.Right - Host.BoundsRect.Right, 0);
				Host.BoundsRect := R;
			end;
		end;
	finally
		Application.EndWrite
	end;
end;

function EnumerateFilerWindows(Proc: CEachFilerWindow; Context: Pointer): TFilerWindow;

	function Compare(A, B: TFilerWindow): Boolean;
	var
		AP, BP: TPoint;
	begin
		AP := A.Position;
		BP := B.Position;
		if AP.X > BP.X then
			Result := False
		else if (AP.X = BP.X) and (AP.Y > BP.Y) then
			Result := False
		else
			Result := True
	end;

	var Windows: array[0..128] of TFilerWindow;
	var WindowCount: Integer;

	function EnumFilerWindowsProc(W: HWND): Boolean; cdecl;
		procedure Process;
		var
			L: TAnyWindow;
		begin
			L := GetLWnd(W);
			if L is TFilerWindow then
			begin
				Windows[WindowCount] := TFilerWindow(L);
				Inc(WindowCount);
			end;
		end;
	var
		Thread: T0GUIThread;
		Entry: TApplicationSynchronizerEntry;
	begin
		Thread := GetLWndThread(W);
		if Thread <> nil then
		begin
			if Thread = CurrentThread then
      	Process
			else
			begin
				Entry.Initialize(CRendezvous(@Process), GetContext);
				Thread.Rendezvous(@Entry);
				Entry.Finalize;
			end
		end;
		Result := False;
	end;

var
	I, J: Integer;
	T: TFilerWindow;
begin
	WindowCount := 0;
	EnumerateWindows(CEachWindow(@EnumFilerWindowsProc), GetContext);

	for I := 1 to WindowCount - 1 do
		for J := I - 1 downto 0 do
		begin
			if Compare(Windows[J], Windows[J + 1]) then
				Break;

			T := Windows[J];
			Windows[J] := Windows[J + 1];
			Windows[J + 1] := T;
		end;

	for I := 0 to WindowCount - 1 do
	begin
		Result := Windows[I];
		if Proc(Result, Context) then Exit;
	end;
	Result := nil
end;

function FilerWindowCount: Integer;
begin
	Result := InterlockedExchangeAdd(_FilerWindowCount, 0)
end;

function ActiveView: TFilerView;
begin
	if CurrentThread is TViewThread then
	begin
		Result := TFilerWindow(T0GUIThread(CurrentThread).MainWindow).ActiveView
	end
	else
  	Result := nil
end;

function SelectFolder(const Title: WideString; out Path: TPath): Boolean;

	var Dialog: TSelectDialog;
	var DialogCheckBox: TCheckBox;

	procedure DialogAdjust;
	var
		R: TRect;
	begin
		R := Dialog.SpaceRect;
		DialogCheckBox.SetBounds(4, R.Top, 1000, R.Bottom - R.Top);
	end;

	function DialogValid: Boolean; cdecl;
	var
		BrowseFolderDialog: TBrowseFolderDialog;
		Path: PPath;
		Selected, NewItem: T0ControlItem;
	begin
		Selected := Dialog.List.At[Dialog.List.SelectedIndex];
		Result := Selected.Data <> nil;
		if not Result then
		begin
			BrowseFolderDialog := TBrowseFolderDialog.Create(Dialog, Dialog.Text);
			BrowseFolderDialog.Owner := Garbage;
			BrowseFolderDialog.Directory := ActiveView.Model.Path.Directory;
			BrowseFolderDialog.Styles := [bfShowText, bfOnlyDir];
			BrowseFolderDialog.AutoShowPath := True;
			if BrowseFolderDialog.Execute then
			begin
				New(Path);
				InitializePath(Path^);
				Path^.Directory := BrowseFolderDialog.Directory;
				NewItem := Dialog.List.Insert(Selected);
				NewItem.Data := Path;
				NewItem.Text := Path^.Directory;
				Dialog.List.SetFocus;
				Dialog.List.Selected := NewItem;
				//Dialog.AdjustSize;
				DialogAdjust;
				DialogCheckBox.Checked := True
			end;
		end;
	end;

	var View: TFilerView;
	var Context: Pointer;

	procedure AddView(AView: TFilerView);

		function EnumItem(Item: T0ControlItem): Boolean; cdecl;
		begin
			Result := ComparePath(PPath(Item.Data)^, AView.Model.Path)
		end;

	var
		P: PPath;
		Item: T0ControlItem;
	begin
		if not (fpPlaceFile in AView.Model.Possibilities) then Exit;
		if Dialog.Enumerate(CEachItem(@EnumItem), GetContext) <> nil then Exit;

		Item := Dialog.Add;
		New(P);
		P^ := CopyPath(AView.Model.Path);
		Item.Data := P;
		Item.Text := AView.Model.DisplayText;
		if AView.Model = View.Model then
			Item.Text := '. (' + Item.Text + ')'
	end;

	function AddViewNotCurrent(V: TFilerView): Boolean; cdecl;
	begin
		if V.Model <> View.Model then
			AddView(V);
		Result := False;
	end;

	function AddWindowNotCurrent(Window: TFilerWindow): Boolean; cdecl;
	begin
		if Window <> View.HostWindow then
			Window.EnumerateViews(CEachFilerView(@AddViewNotCurrent), Context);
		Result := False;
	end;

	procedure ClearDialog;

		function Enum(Item: T0ControlItem): Boolean; cdecl;
		var
			P: PPath;
		begin
			P := Item.Data;
			if P <> nil then
			begin
				FinalizePath(P^);
				Dispose(P);
			end;
			Result := False;
		end;

	begin
		Dialog.Enumerate(CEachItem(@Enum), GetContext)
	end;

var
	PP, OpenPath: PPath;
begin
	View := ActiveView;
	Context := GetContext;

	Dialog := TSelectDialog.Create(View.HostWindow, Title);
	Dialog.Owner := Garbage;
	Dialog.Context := Context;
	Dialog.OnQuery := Pointer(@DialogValid);

	View.HostWindow.EnumerateViews(CEachFilerView(@AddViewNotCurrent), Context);
	EnumerateFilerWindows(CEachFilerWindow(@AddWindowNotCurrent), Context);
	AddView(View);
	with Dialog.Add do begin Text := '...'; Data := nil; end;

	DialogCheckBox := TCheckBox.Create(Dialog, 'ItH_J(&S)', ZeroPoint, DefaultSize);
	Dialog.SpaceSize := DialogCheckBox.BoundsSize;
	DialogAdjust;

	Result := Dialog.Execute;
	if Result then
	begin
		PP := Dialog.Selected.Data;
		Assert(PP <> nil);
		Path := CopyPath(PP^);

		if DialogCheckBox.Checked then
		begin
			New(OpenPath);
			OpenPath^ := CopyPath(PP^);
			View.PostMessageW(WM_APP_OPENVIEW, 0, LPARAM(OpenPath))
		end;
	end;

	ClearDialog;
end;

{ TFilerView }

function CompMix(I1, I2: Integer; Data: Pointer): Integer; cdecl;
var
	Data1, Data2: PFile;
begin
	Data1 := TFilerView(Data).FItems[I1];
	Data2 := TFilerView(Data).FItems[I2];

	Result := CompareFileName(Data1^.Name, Data1^.NameLength,
					Data2^.Name, Data2^.NameLength);
end;

function CompMixR(I1, I2: Integer; Data: Pointer): Integer; cdecl;
begin
	Result := CompMix(I2, I1, Data)
end;

function CompFile(I1, I2: Integer; Data: Pointer): Integer; cdecl;
var
	Data1, Data2: PFile;
begin
	Data1 := TFilerView(Data).FItems[I1];
	Data2 := TFilerView(Data).FItems[I2];

	Result := Data2^.Attributes and faDirectory - Data1^.Attributes and faDirectory;

	if Result = 0 then
	begin
		if Data1^.Attributes and faDirectory <> 0 then
		begin
			Result := Data1^.Attributes and FILE_ATTRIBUTE_REPARSE_POINT - Data2^.Attributes and FILE_ATTRIBUTE_REPARSE_POINT;
			if Result = 0 then
{			Result := Ord(Data2^.Name[0] = '.') - Ord(Data1^.Name[0] = '.');
			if Result = 0 then
}
				Result := CompareFileName(
							Data1^.DisplayName, Data1^.DisplayNameLength,
							Data2^.DisplayName, Data2^.DisplayNameLength);
		end
		else
		begin
			case TFilerView(Data).SortMode of
			smFileExt, smFileExtR:
				Result := CompareFileName(
							ExtractFileExt(Data1^.Name),
							ExtractFileExt(Data2^.Name));
			smSize, smSizeR:
				Result := Data1^.Size - Data2^.Size;
			smWrite, smWriteR:
				Result := CompareFileTime(
								Data1^.LastWriteTime,
								Data2^.LastWriteTime);
			smAccess, smAccessR:
				Result := CompareFileTime(
								Data1^.LastAccessTime,
								Data2^.LastAccessTime);
			end;
			if Result = 0 then
				Result := CompareFileName(
								Data1^.DisplayName, Data1^.DisplayNameLength,
								Data2^.DisplayName, Data2^.DisplayNameLength);
		end;
	end;
end;

function CompFileR(I1, I2: Integer; Data: Pointer): Integer; cdecl;
begin
	Result := CompFile(I2, I1, Data)
end;

procedure SwapFile(I1, I2: Integer; Data: Pointer); cdecl;
var
	Temp: Pointer;
begin
	Temp := TFilerView(Data).FItems[I1];
	TFilerView(Data).FItems[I1] := TFilerView(Data).FItems[I2];
	TFilerView(Data).FItems[I2] := Temp;
end;

constructor TFilerView.Create(AParent: TFilerWindow; Next: TFilerView; const AModel: IFolder);
begin
	inherited Create(AParent, ZeroPoint, ZeroSize);

	CtrlOptions := [loMultiSelect];
	FModel := AModel;

	AddToLinkList(AParent.FFirstView, AParent.FLastView,
					Self, FPredView, FSuccView, Next);
	Inc(AParent.FViewCount);

	if ApplicationSkinTemplate.FlatScrollBar then
		ScrollBarManager := FlatScrollBarManager;
end;

procedure TFilerView.Initialize;

	function EachExtension(const E: IExtension): Boolean cdecl;
	var
		V: IViewHandler;
	begin
		if Supports(E, IViewHandler, V) then V.OnOpen(Self);
		Result := False;
	end;

begin
	inherited Initialize;

	BringToFront(FSuccView);

	Font := Parent.Font;

	FFaceFont := TFont.Create;
	FFaceFont.Owner := Self;
	FFaceFont.FaceName := ApplicationSkinTemplate.FaceName;
	FFaceFont.Height := Font.Height;

	FPen := TPen.Create;
	FPen.Owner := Self;

	FSortMode := smName;

	SetWildCard((Application as IEOFileGlobal).InitialFilter);
	SetModel(FModel);

	//ScrollBarManager.SetScrollProp(Handle, WSB_PROP_VSTYLE, FSB_REGULAR_MODE, False);
	//ScrollBarManager.SetScrollProp(Handle, WSB_PROP_VSTYLE, FSB_ENCARTA_MODE, False);
	ScrollBarManager.SetScrollProp(Handle, WSB_PROP_VBKGCOLOR, $998888, False);

	RegisterDragDrop(Handle, Self);

	(Application as IExtensionManager).Enumerate(CEachExtension(@EachExtension), GetContext);
end;

procedure TFilerView.Finalize;

	function EachExtension(const E: IExtension): Boolean cdecl;
	var
		V: IViewHandler;
	begin
		if Supports(E, IViewHandler, V) then V.OnClose(Self);
		Result := False;
	end;

var
	Host: TFilerWindow;
	S, P: TFilerView;
begin
	(Application as IExtensionManager).Enumerate(CEachExtension(@EachExtension), GetContext);

	RevokeDragDrop(Handle);

	S := FSuccView;
	P := FPredView;

	{View̖ڂI}

	Host := HostWindow;
	RemoveFromLinkList(Host.FFirstView, Host.FLastView,
					Self, FPredView, FSuccView);
	Dec(Host.FViewCount);

	{tH[JXn}

	if HostWindow.Visible then
	begin
		if S <> nil then
			S.SetFocus
		else if P <> nil then
			P.SetFocus;
	end;

	{Model̊Ď~߂}
	SetModel(nil);

	{tB^}
	if FWildCard <> nil then
		Dispose(FWildCard, Finalize);

	{XL}
	DeleteObject(FSkin.Background);
	DeleteObject(FSkin.Info);
	DeleteObject(FSkin.NameSpace);
	DeleteObject(FSkin.Founds);
	DeleteObject(FSkin.Archive);

	inherited;
end;

procedure TFilerView.FontChanged;
begin
	FFontSize := GetFontSize(Font.Handle, StandardFontWidth);

	BoundsSize := Size(FFontSize.CX * 48 + 4 + GetSystemMetrics(SM_CXVSCROLL), 0);
	ItemHeight := FFontSize.CY * 2;

	inherited;
end;

function TFilerView.HostWindow: TFilerWindow;
begin
	Assert(Parent is TFilerWindow);
	Result := TFilerWindow(Parent)
end;

procedure TFilerView.ModelUpdate;
begin
	ViewUpdate(False);
end;

procedure TFilerView.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
	inherited;
	if Message.CalcValidRects then
	begin
		FInfoHeight := FFontSize.CY * 4 + 5;
		Inc(Message.CalcSize_Params.rgrc[0].Top, FInfoHeight);
	end;
end;

procedure TFilerView.WMNCHitTest(var Message: TWMNCHitTest);
begin
	inherited;
	if Message.Result = HTNOWHERE then
		Message.Result := HTINFOSPACE;
end;

procedure TFilerView.WMNCPaint(var Message: TWMNCPaint);
var
	DC, BmpDC: HDC;
	BorderWidth, NumPos: Integer;
	R, Clipped: TRect;
	Path, Num: WideString;
	X, Y, Processed, Next, Len, PreCount: Integer;
	Width: TSize;
	PPath, PWild: PWideChar;
	Founds: IFounds;
	WindowSize: TSize;
	BF: DWORD;
	Region: HRGN;
	I: TFilerView;
	Bitmap: Windows.BITMAP;
begin
	WindowSize := BoundsSize;
	BorderWidth  := (WindowSize.CY - ClientSize.CY - FInfoHeight) div 2;

	DC := GetWindowDC(Handle);
	SaveDC(DC);

	R.Left   := 0;
	R.Top    := 0;
	R.Right  := WindowSize.CX;
	R.Bottom := FInfoHeight;
	BF := BF_RECT or BF_ADJUST;
	if FPredView <> nil then BF := BF and not BF_LEFT;
	if FSuccView <> nil then BF := BF and not BF_RIGHT;
	DrawEdge(DC, R, EDGE_SUNKEN, BF);

	if FSkin.Info = 0 then
		FillRect(DC, R, GetStockObject(BLACK_BRUSH))
	else
	begin
		BmpDC := CreateCompatibleDC(DC);
		SelectObject(BmpDC, FSkin.Info);
		if GetObjectW(FSkin.Info, SizeOf(Bitmap), @Bitmap) = 0 then
		begin
			Bitmap.bmWidth := GetDeviceCaps(BmpDC, LOGPIXELSX);
			Bitmap.bmHeight := GetDeviceCaps(BmpDC, LOGPIXELSY);
		end;

		PreCount := 0;
		I := Self.FPredView;
		while I <> nil do
		begin
			Inc(PreCount);
			I := I.FPredView;
		end;

		X := - PreCount * WindowSize.CX;
		Y := (FInfoHeight - Bitmap.bmHeight) div 2;
		repeat
			Clipped.Left := X;
			Clipped.Top := Y;
			Clipped.Right := Clipped.Left + Bitmap.bmWidth;
			Clipped.Bottom := Clipped.Top + Bitmap.bmHeight;

			if Clipped.Left   < R.Left   then Clipped.Left   := R.Left;
			if Clipped.Right  > R.Right  then Clipped.Right  := R.Right;
			if Clipped.Top    < R.Top    then Clipped.Top    := R.Top;
			if Clipped.Bottom > R.Bottom then Clipped.Bottom := R.Bottom;

			BitBlt(DC, Clipped.Left, Clipped.Top,
				Clipped.Right - Clipped.Left, Clipped.Bottom - Clipped.Top,
				BmpDC, Clipped.Left - X, Clipped.Top - Y, SRCCOPY);

			Inc(X, Bitmap.bmWidth);
		until Succ(X) >= WindowSize.CX;
		DeleteDC(BmpDC);
	end;

	R.Left   := 0;
	R.Top    := FInfoHeight;
	R.Right  := WindowSize.CX;
	R.Bottom := WindowSize.CY;
	DrawEdge(DC, R, EDGE_SUNKEN, BF_RECT and not BF_BOTTOM);

	if Focused and TopParent.IsForeground then
		SetTextColor(DC, $ffff00)
	else
		SetTextColor(DC, GetSysColor(COLOR_INFOBK));

	SetBkMode(DC, TRANSPARENT);
	SelectObject(DC, Font.Handle);

	if Model <> nil then
	begin
		{pX`}

		Path := Model.DisplayText;

		if Path <> '' then
		begin
			PPath := Pointer(Path);
			Processed := 0;
			Next := 0;
			Len := Length(Path);
			X := BorderWidth + 1;
			Y := BorderWidth + 1;
			while Processed < Len do
			begin
				repeat
					Inc(Next);
				until (Path[Next] = '\') or (Path[Next] = '/') or (Next = Len) or
								((Path[Next + 1] = ':') and (Path[Next + 2] = ':'));

				GetTextExtentPoint32W(DC, PPath + Processed, Next - Processed, Width);
				if X + Width.CX > R.Right then
				begin
					X := BorderWidth + FFontSize.cx * 4;
					Inc(Y, FFontSize.cy);
				end;

				TextOutW(DC, X, Y, PPath + Processed, Next - Processed);
				Inc(X, Width.CX);

				Processed := Next;
			end;
		end;

		{ChJ[h`}

		if FWildCard = nil then
		begin
			Num := WideFormat('%4d/%4d', [SelectCount, ItemCount]);
			NumPos := 50 - Length(Num);

			PWild := nil;
			Len := 0;
			if Supports(Model, IFounds, Founds) then
			begin
				PWild := PWideChar(Founds.WildCard);
				Len := Length(Founds.WildCard);
			end;
		end
		else
		begin
			Num := WideFormat('%4d/%4d/%4d', [SelectCount, ItemCount, Model.Count]);
			NumPos := 50 - Length(Num);

			PWild := PWideChar(FWildCard.Source);
			Len := Length(FWildCard.Source);
		end;

		if PWild <> nil then
		begin
			if Len < NumPos then
				Windows.TextOutW(DC, 3, FFontSize.CY * 3 + 3, PWild, Len)
			else
			begin
				Windows.TextOutW(DC, 3, FFontSize.CY * 3 + 3, PWild, NumPos - 4);
				Windows.TextOutW(DC, 3 + FFontSize.CX * (NumPos - 4), FFontSize.CY * 3 + 3, '...', 3)
			end;
		end;
		TextOut(DC, 3 + FFontSize.CX * NumPos, FFontSize.CY * 3 + 3, Num);
	end;

	RestoreDC(DC, -1);
	ReleaseDC(Handle, DC);

	GetWindowRect(Handle, R);
	Region := CreateRectRgn(R.Left, R.Top + FInfoHeight + BorderWidth, R.Right, R.Bottom);
	Message.RGN := Region;
	inherited;
	DeleteObject(Region);
end;

procedure TFilerView.SetModel(const Value: IFolder);
begin
	{̃\bh͑̃Xbhs}

	Application.BeginWrite;
	try
		if FModel <> nil then
		begin
			FModel.Detach(Self);
		end;

		FModel := Value;

		if FModel <> nil then
		begin
			FModel.Attach(Self);

			{GNXeVɃXLI΂}
			PostMessageW(WM_APP_UPDATESKIN, 0, 0);

			{XV}
			ViewUpdate(True);
			Parent.PostMessageW(WM_APP_REALIGN, 0, 0);
		end
	finally
		Application.EndWrite;
	end;
end;

procedure TFilerView.ViewUpdate(Replace: Boolean);
var
	OldItems: TFilePtrArray;
	OldCaretIndex, OldScrollFrom: Integer;
	OldScrollBase: TLightListBox.TScrollBase;
	I, J, V: Integer;
	M2: IFolder;
	PF: PFile;
	IsDirectory: Boolean;
begin
	{̃\bh͑̃Xbhs}

	if Model = nil then
		ItemCount := 0
	else if not Model.Valid then
	begin
		Application.BeginWrite;
		try
			repeat
				M2 := GetParentFolder(Model);
			until M2.Valid;
			Model := M2;
		finally
			Application.EndWrite;
		end
	end
	else
	begin
		Inc(FUpdating);
		try
			IsDirectory := Supports(Model, IDirectory);

			{IԂۑ}
			OldItems := nil;
			OldCaretIndex := 0;
			OldScrollFrom := 0;
			OldScrollBase := lsbTop;

			if not Replace then
			begin
				OldItems := FItems;
				FItems := nil;

				for I := High(OldItems) downto Low(OldItems) do
					OldItems[I].Work := Ord(Selected[I]);

				OldScrollFrom := ScrollFrom;
				OldScrollBase := ScrollBase;
				OldCaretIndex := CaretIndex;
			end;

			if (FWildCard = nil) or not IsDirectory then
			begin
				SetLength(FItems, Model.Count);
				for I := Model.Count - 1 downto 0 do
					FItems[I] := Model.Items[I];
			end
			else
			begin
				SetLength(FItems, Model.Count);
				V := 0;
				for I := 0 to Model.Count - 1 do
				begin
					PF := Model.Items[I];
					if (PF^.Attributes and faDirectory <> 0) or
									FWildCard.Evaluate(PF^.Name, PF^.Attributes) then
					begin
						FItems[V] := PF;
						Inc(V);
					end;
				end;
				SetLength(FItems, V);
			end;

			if (fpSort in Model.Possibilities) and (SortMode <> smNone) then
				case SortMode of
				smNone:
					;
				smNameMix:
					QuickSort(Low(FItems), High(FItems), CompMix, SwapFile, Self);
				smNameMixR:
					QuickSort(Low(FItems), High(FItems), CompMixR, SwapFile, Self);
				smNameR, smFileExtR, smSizeR, smWriteR, smAccessR:
					QuickSort(Low(FItems), High(FItems), CompFileR, SwapFile, Self);
				else
					QuickSort(Low(FItems), High(FItems), CompFile, SwapFile, Self);
				end;

			ItemCount := 0;
			ItemCount := Length(FItems);

			if not Replace then
			begin
				for I := High(OldItems) downto Low(OldItems) do
					if OldItems[I].Work <> 0 then
						for J := ItemCount - 1 downto 0 do
							if lstrcmpW(OldItems[I]^.Name, FItems[J]^.Name) = 0 then
							begin
								Selected[J] := True;
								Break;
							end;

				if OldCaretIndex >= ItemCount then
					OldCaretIndex := ItemCount - 1
				else if (OldCaretIndex < 0) and (ItemCount > 0) then
					OldCaretIndex := 0;

				Scroll(OldScrollBase, OldScrollFrom);
				CaretIndex := OldCaretIndex;
			end;
		finally
			Dec(FUpdating)
		end;

		PostMessageW(WM_LIGHTWINDOWS, LW_NCPAINT, 0);
	end;
	OldItems := nil; {...}
end;

function TFilerView.CanSelectItem(Index: Integer): Boolean;
begin
	//Result := FItems[Index]^.Name[0] <> '.'
	Result := True
end;

procedure TFilerView.DoSelectItem(Index: Integer; Value: Boolean);
begin
	inherited;
	if FUpdating = 0 then RepaintFrame;
end;

procedure TFilerView.DrawItem(Index: Integer; DC: HDC; const Rect: TRect);

	function ColorChoice(Data: PFile): COLORREF;
	begin
		if Data^.Kind = fkDrive then
			Result := FSkin.FileName
		else if faSysFile and Data^.Attributes <> 0 then
			Result := FSkin.SystemFile
		else if faHidden and Data^.Attributes <> 0 then
			Result := FSkin.Hidden
		else if faReadOnly and Data^.Attributes <> 0 then
			Result := FSkin.ReadOnly
		else if (foEnter in Data^.Operatable) and (Data^.Kind <> fkFile) or
						(Data^.Attributes and faDirectory <> 0) then
			Result := FSkin.Directory
		else if Data^.Kind = fkVirtual then
			Result := FSkin.Virtual
		else
			Result := FSkin.FileName
	end;

type
	TBuffer422 = packed record
		First:  array[0..3] of Char; S1: Char;
		Second: array[0..1] of Char; S2: Char;
		Third:  array[0..1] of Char; S3: Char;
	end;
	Int64Rec = packed record
		Low, High: LongWord;
	end;
var
	FTime: FILETIME;
	Time: SYSTEMTIME;
	Buffer: array[0..19] of Char;
	Buffer422: TBuffer422 absolute Buffer;
	Work: WideString;
	FileName, Ext: PWideChar;
	FileLen: Integer;
	X, Y: Integer;
	Data: PFile;
	Dev: PWideChar;
begin
	SaveDC(DC);
	SetBkMode(DC, TRANSPARENT);

	Data := FItems[Index];

	// First Line
	SelectObject(DC, FFaceFont.Handle);

	X := Rect.Left + FFontSize.CX;
	Y := Rect.Top;

	// Long File Name

	SetString(Work, Data^.DisplayName, Data^.DisplayNameLength);

	SelectObject(DC, FPen.Handle);
	MoveToEx(DC, X + GetTextSize(DC, Work).cx, Y + FFontSize.CY div 2, nil);
	LineTo(DC, FFontSize.CX * 47, Y + FFontSize.CY div 2);
	LineTo(DC, FFontSize.CX * 47, Y + FFontSize.CY);

	if Selected[Index] then
		SetTextColor(DC, FSkin.Selected)
	else
		SetTextColor(DC, ColorChoice(Data));

	TextOut(DC, X, Y, MinimizeName(Work, DC, FFontSize.CX * 46));

	// Second Line
	SelectObject(DC, Font.Handle);
	Inc(Y, FFontSize.CY);

	if Data^.Kind = fkDrive then
	begin
		SetTextColor(DC, FPen.Color);

		TextOutW(DC, X, Y, Data^.Name, 2);

		SetTextColor(DC, FSkin.InfoTexts[Selected[Index]]);

		//Type

		case Data^.DriveType of
		DRIVE_REMOVABLE: Dev := 'Removable   ';
		DRIVE_FIXED:     Dev := 'Hard-Disk   ';
		DRIVE_REMOTE:    Dev := 'Remote-Drive';
		DRIVE_CDROM:     Dev := 'Compact-Disk';
		DRIVE_RAMDISK:   Dev := 'RAM-Disk    ';
		else             Dev := '???         ';
		end;

		TextOutW(DC, X + FFontSize.CX * 4, Y, Dev, 12);

		//Format

		TextOutW(DC, X + FFontSize.CX * 17, Y,
						Data^.FileSystem, Data^.FileSystemLength);

		//Size

		if Data^.Size <> -1 then
		begin
			StrFmt(Buffer, '%19d', [Data^.Size]);
			Windows.TextOut(DC, X + FFontSize.CX * 27, Y, Buffer, 19);
		end;
	end
	else
	begin
		SetTextColor(DC, FPen.Color);

		if Data^.Kind = fkVirtual then
		begin
			SetString(Work, Data^.Name, Data^.NameLength);
			TextOut(DC, X, Y, MinimizeName(Work, DC, FFontSize.CX * 46));
		end
		else
		begin
			// Short File Name
			FileName := Data^.Name;
			FileLen := Data^.NameLength;

			if ApplicationSkinTemplate.ShortFileName and (Data^.ShortNameLength > 0) then
			begin
				FileName := Data^.ShortName;
				FileLen := Data^.ShortNameLength;
			end;

			Ext := WideStrRScan(FileName, '.');

			if Ext = nil then
			begin
				if ApplicationSkinTemplate.ShortFileName then
					TextOutW(DC, X, Y, FileName, FileLen)
			end
			else
			begin
				if ApplicationSkinTemplate.ShortFileName then
					TextOutW(DC, X, Y, FileName, Ext - FileName);

				Inc(Ext);
				TextOutW(DC, X + FFontSize.CX * 9, Y, Ext, FileLen - (Ext - FileName));
			end;

			SetTextColor(DC, FSkin.InfoTexts[Selected[Index]]);

			// Size or Dir

			if Data^.Attributes and FILE_ATTRIBUTE_REPARSE_POINT <> 0 then
				Windows.TextOut(DC, X + FFontSize.CX * 13, Y, '<< link >>', 10)
			else if Data^.Attributes and faDirectory <> 0 then
				Windows.TextOut(DC, X + FFontSize.CX * 13, Y, '<< dir. >>', 10)
			else
			begin
				Str(Data^.Size: 10, Buffer);
				Windows.TextOut(DC, X + FFontSize.CX * 13, Y, Buffer, 10);
			end;

			// Time
			if Int64(Data^.LastWriteTime) <> 0 then
			begin
				FileTimeToLocalFileTime(Data^.LastWriteTime, FTime);
				FileTimeToSystemTime(FTime, Time);

				Str(Time.wYear :4, Buffer422.First);
				Str(Time.wMonth:2, Buffer422.Second);
				Str(Time.wDay  :2, Buffer422.Third);
				if Buffer422.Second[0] = #32 then Buffer422.Second[0] := '0';
				if Buffer422.Third[0]  = #32 then Buffer422.Third[0]  := '0';
				Buffer422.S1 := '-';
				Buffer422.S2 := '-';

				Windows.TextOut(DC, X + FFontSize.CX * 24, Y, Buffer + 2, 8);

				Str(Time.wHour  :4, Buffer422.First);
				Str(Time.wMinute:2, Buffer422.Second);
				Str(Time.wSecond:2, Buffer422.Third);
				if Buffer422.First[2]  = #32 then Buffer422.First[2]  := '0';
				if Buffer422.Second[0] = #32 then Buffer422.Second[0] := '0';
				if Buffer422.Third[0]  = #32 then Buffer422.Third[0]  := '0';
				Buffer422.S1 := ':';
				Buffer422.S2 := ':';

				Windows.TextOut(DC, X + FFontSize.CX * 33, Y, Buffer + 2, 8);
			end;

			// Attr
			if Data^.Number < High(Word) then
			begin
				Str(Data^.Number: 4, Buffer);
				Windows.TextOut(DC, X + FFontSize.CX * 42, Y, Buffer, 4);
			end
			else
			begin
				FillChar(Buffer, 4, '-');
				if Data^.Attributes and faReadOnly <> 0 then Buffer[0] := 'R';
				if Data^.Attributes and faHidden   <> 0 then Buffer[1] := 'H';
				if Data^.Attributes and faSysFile  <> 0 then Buffer[2] := 'S';
				if Data^.Attributes and faArchive  <> 0 then Buffer[3] := 'A';

				Windows.TextOut(DC, X + FFontSize.CX * 42, Y, Buffer, 4);
			end
		end;
	end;
	RestoreDC(DC, -1);
end;

function TFilerView.FocusedFile: PFile;
begin
	if CaretIndex < 0 then raise Exception.Create(SNoAllowed);
	Result := FItems[CaretIndex]
end;

function TFilerView.KeyDown(ShiftState: TShiftKeys; Code: Byte): Boolean;
var
	Action: IAction;
begin
	Action := HostWindow.FKeyManager.FindAction(ShiftState, Code);
	if Action <> nil then begin
		if not Action.Execute then Beep;
		Result := True;
	end else begin
		Result := inherited KeyDown(ShiftState, Code);
	end
end;

procedure TFilerView.WMDrawItem(var Message: TWMDrawItem);
begin
	if not ProcessContextMenu(TMessage(Message)) then
		inherited
end;

procedure TFilerView.WMInitMenuPopup(var Message: TWMInitMenuPopup);
begin
	if not ProcessContextMenu(TMessage(Message)) then
		inherited;
end;

procedure TFilerView.WMMeasureItem(var Message: TWMMeasureItem);
begin
	if not ProcessContextMenu(TMessage(Message)) then
		inherited
end;

function TFilerView.ProcessContextMenu(var Message: TMessage): Boolean;
var
	CM2: IContextMenu2;
begin
	Result := FContextMenu <> nil;
	if Result and Supports(FContextMenu, IContextMenu2, CM2) then
		CM2.HandleMenuMsg(Message.Msg, Message.WParam, Message.LParam)
end;

function TFilerView.QueryContextMenu: IContextMenu;
type
	ItemIDListArray = array of PItemIDList;

	function SelectedItemIDLists: ItemIDListArray;
	var
		C, I, J: Integer;
	begin
		C := SelectCount;
		if C = 0 then
		begin
			if CaretIndex >= 0 then
			begin
				SetLength(Result, 1);
				Result[0] := FItems[CaretIndex]^.Data;
			end
			else
				Result := nil
		end
		else
		begin
			SetLength(Result, C);
			J := Low(Result);
			for I := 0 to ItemCount - 1 do
				if Selected[I] then
				begin
					Result[J] := FItems[I]^.Data;
					Inc(J);
				end;
		end;
	end;

	function MakeContextMenuInNameSpace: IContextMenu;
	var
		ItemIDLists: ItemIDListArray;
		Folder: IShellFolder;
	begin
		ItemIDLists := SelectedItemIDLists;
		Folder := Model as IShellFolder;
		Folder.GetUIObjectOf(Handle, Length(ItemIDLists), ItemIDLists[0],
						IContextMenu, nil, Result);
	end;

begin
	if Supports(Model, IDirectory) then
		Result := CreateContextMenu(Handle, Model.Path.Directory,
			FilePtrArray2WideFileNameArray(SelectedFiles))
	else if Supports(Model, IFounds) then
	begin
		if (SelectCount = 0) and (ItemCount > 0) then
			Result := CreateContextMenu(Handle, ConcatPath(Model.Path.Directory, FocusedFile^.Name))
		else
			Result := nil
	end
	else if Supports(Model, INameSpace) then
		Result := MakeContextMenuInNameSpace
	else
		Result := nil
end;

procedure TFilerView.WMContextMenu(var Message: TWMContextMenu);
var
	Menu: HMENU;
	Cmd: UINT;
	CmdInfo: CMINVOKECOMMANDINFOEX;
	P: TPoint;
	R: TRect;
	WideDir: WideString;
	AnsiDir: AnsiString;
begin
	{inheritedƂTLightListBox͉ĂȂ̂Ŗ}

	Menu := CreatePopupMenu;
	try
		FContextMenu := QueryContextMenu;

		if FContextMenu <> nil then
		begin
			FContextMenu.QueryContextMenu(Menu, 0, $1000, $7fff, CMF_EXPLORE);

			P.X := Message.XPos;
			P.Y := Message.YPos;
			if P.X < 0 then
			begin
				R := ItemRect(CaretIndex);
				P.X := R.Left;
				P.Y := R.Bottom;
				P := ClientToScreen(P);
			end;

			Cmd := UINT(TrackPopupMenu(Menu, TPM_RETURNCMD or TPM_RIGHTBUTTON, P.X, P.Y, 0, Handle, nil));

			if Cmd > 0 then
			begin
				WideDir := Model.Path.Directory;
				AnsiDir := WideDir;

				FillChar(CmdInfo, SizeOf(CmdInfo), 0);
				CmdInfo.cbSize  := SizeOf(CmdInfo);
				CmdInfo.fMask   := CMIC_MASK_UNICODE;
				CmdInfo.HWnd    := Handle;
				CmdInfo.nShow   := SW_SHOWNORMAL;
				{Ansi}
				CmdInfo.lpVerb      := PChar(Cmd - $1000);
				CmdInfo.lpDirectory := PChar(AnsiDir);
				{Wide}
				CmdInfo.lpVerbW      := PWideChar(Cmd - $1000);
				CmdInfo.lpDirectoryW := PWideChar(WideDir);

				FContextMenu.InvokeCommand(PCMINVOKECOMMANDINFO(@CmdInfo)^);
			end
		end
	finally
		DestroyMenu(Menu);
		FContextMenu := nil;
	end;
end;

function TFilerView.SelectedFiles: TFilePtrArray;
var
	C, I, J: Integer;
begin
	C := SelectCount;

	if C = 0 then
	begin
		if CaretIndex >= 0 then
		begin
			SetLength(Result, 1);
			Result[0] := FItems[CaretIndex];
		end
		else
			Result := nil
	end
	else
	begin
		SetLength(Result, C);
		J := Low(Result);
		for I := 0 to ItemCount - 1 do
			if Selected[I] then
			begin
				Result[J] := FItems[I];
				Inc(J);
			end;
	end;
end;

procedure TFilerView.BeginUpdate;
begin
	Inc(FUpdating)
end;

procedure TFilerView.EndUpdate;
begin
	Dec(FUpdating);
	RepaintFrame;
end;

procedure TFilerView.FocusTo(const AName: TWideFileName);
var
	I: Integer;
begin
	for I := 0 to ItemCount - 1 do
		if CompareFileName(FItems[I]^.Name, FItems[I]^.NameLength, PWideChar(AName), Length(AName)) = 0 then
		begin
			CaretIndex := I;
			Break;
		end;
end;

procedure TFilerView.FocusNear(const AName: TWideFileName);
var
	L, I: Cardinal;
begin
	for L := Length(AName) downto 1 do
		for I := 0 to ItemCount - 1 do
			if FItems[I]^.NameLength >= L then
				if CompareFileName(FItems[I]^.Name, L, PWideChar(AName), L) = 0 then
				begin
					CaretIndex := I;
					Exit
				end;
end;

procedure TFilerView.FocusNearWithDisplayName(const AName: WideString);
var
	L, I: Cardinal;
begin
	for L := Length(AName) downto 1 do
		for I := 0 to ItemCount - 1 do
			if FItems[I]^.DisplayNameLength >= L then
				if CompareFileName(FItems[I]^.DisplayName, L, PWideChar(AName), L) = 0 then
				begin
					CaretIndex := I;
					Exit
				end;
end;

function TFilerView.GetWildCard: WideString;
begin
	if FWildCard <> nil then
		Result := FWildCard.Source
	else
		Result := ''
end;

procedure TFilerView.SetWildCard(const Value: WideString);
var
	NewWildCard: PWildCardExpression;
	Error: TWildCardErrorKind;
begin
	NewWildCard := nil;
	if (Value <> '') and (Value <> '"*.*"') and (Value <> '"*"') then
	begin
		New(NewWildCard, Initialize(Value, Error));
		if Error <> weNone then raise Exception.Create('ChJ[h܂.');
	end;

	if FWildCard <> nil then Dispose(FWildCard, Finalize);
	FWildCard := NewWildCard;
	ViewUpdate(True)
end;

procedure TFilerView.SetSortMode(const Value: TSortMode);
begin
	FSortMode := Value;
	ViewUpdate(True)
end;

function TFilerView.GetItems(Index: Integer): PFile;
begin
	Result := FItems[Index]
end;

function TFilerView.DragEnter(const dataObj: IDataObject;
	grfKeyState: Integer; pt: TPoint; var dwEffect: Integer): HResult;
begin
	FDragDropAccepting := dataObj.QueryGetData(HDropFormat) = S_OK;
	if FDragDropAccepting then
		dwEffect := KeysToDropEffect(grfKeyState)
	else
		dwEffect := DROPEFFECT_NONE;

	Result := S_OK;
end;

function TFilerView.DragLeave: HResult;
begin
	FDragDropAccepting := False;
	Result := S_OK
end;

function TFilerView.DragOver(grfKeyState: Integer; pt: TPoint;
	var dwEffect: Integer): HResult;
begin
	if FDragDropAccepting then
		dwEffect := KeysToDropEffect(grfKeyState)
	else
		dwEffect := DROPEFFECT_NONE;

  FRightDragging := grfKeyState and MK_RBUTTON <> 0;

	Result := S_OK
end;

function TFilerView.Drop(const dataObj: IDataObject; grfKeyState: Integer;
	pt: TPoint; var dwEffect: Integer): HResult;
begin
	if FDragDropAccepting and not FDragDropping then
	begin
		if FRightDragging then
		begin
			TMessageBox.Execute('Ehbvo'#13#10'j[͂҂', MB_ICONINFORMATION);
		end
		else
		begin
			dwEffect := KeysToDropEffect(grfKeyState);
			HostWindow.Foreground;
			AcceptDataObject(dataObj, dwEffect);
		end;
	end
	else
	begin
		FDragDropping := False;
		dwEffect := DROPEFFECT_NONE;
	end;
	Result := S_OK;
end;

procedure TFilerView.AcceptDataObject(const DataObject: IDataObject; Effect: DWORD);
var
	M: STGMEDIUM;
	P: PByte;
	Files: TWideFileNameArray;
	A: AnsiString;
	W: WideString;
	Wide: Boolean;
	FromPath: TPath;
begin
	if DataObject.GetData(HDropFormat, M) = S_OK then
	begin
		InitializePath(FromPath);

		P := GlobalLock(M.hGlobal);
		try
			Wide := PDROPFILES(P)^.fWide;
			Inc(P, PDROPFILES(P)^.pFiles);

			Files := nil;
			while P^ <> 0 do
			begin
				{PChar  String ƓɒZo}
				if Wide then
				begin
					W := PWideChar(P);
					Inc(P, (Length(W) + 1) * SizeOf(WideChar));
				end
				else
				begin
					A := PAnsiChar(P);
					Inc(P, (Length(A) + 1) * SizeOf(AnsiChar));
					W := A;
				end;

				if FromPath.Directory = '' then
					FromPath.Directory := ExtractFileDir(W)
				else if CompareFileName(FromPath.Directory, ExtractFileDir(W)) <> 0 then
				begin
					TMessageBox.Execute('L^Ăt@C݈̑ʒu΂΂ł',
									'OLE DataObject ɂt@C̎n', MB_ICONWARNING);
					Exit;
				end;

				SetLength(Files, Length(Files) + 1);
				Files[High(Files)] := ExtractFileName(ExtractLongPathName(W));
			end;
		finally
			GlobalUnlock(M.hGlobal);
			ReleaseStgMedium(M);
		end;

		case Effect of
		DROPEFFECT_COPY:
			TFileOperationThread.Create(fokCopy, FromPath, Model.Path, Files);
		DROPEFFECT_MOVE:
			TFileOperationThread.Create(fokMove, FromPath, Model.Path, Files);
		DROPEFFECT_LINK:
			TFileOperationThread.Create(fokLink, FromPath, Model.Path, Files);
		end;
	end;
end;

function TFilerView.GiveFeedback(dwEffect: Integer): HResult;
begin
	Result := DRAGDROP_S_USEDEFAULTCURSORS
end;

function TFilerView.QueryContinueDrag(fEscapePressed: BOOL; grfKeyState: Integer): HResult;
begin
	if fEscapePressed then
		Result := DRAGDROP_S_CANCEL
	else if grfKeyState and (MK_LBUTTON or MK_RBUTTON or MK_MBUTTON) = 0 then
		Result := DRAGDROP_S_DROP
	else
		Result := S_OK
end;

procedure TFilerView.WMLButtonDown(var Message: TWMLButtonDown);
begin
	GetCursorPos(FMouseDownPos);
	inherited;
end;

procedure TFilerView.WMRButtonDown(var Message: TWMRButtonDown);
begin
	GetCursorPos(FMouseDownPos);
	inherited;
end;

procedure TFilerView.WMMouseMove(var Message: TWMMouseMove);

	function DragDetect(const From: TPoint): Boolean;
	var
		P: TPoint;
	begin
		GetCursorPos(P);
		Result := (Abs(P.X - From.X) > GetSystemMetrics(SM_CXDRAG)) or
						(Abs(P.Y - From.Y) > GetSystemMetrics(SM_CYDRAG))
	end;

var
	DataObject: IDataObject;
	R: Integer;
begin
	if (Message.Keys and (MK_LBUTTON or MK_RBUTTON) <> 0) and (FMouseDownPos.X > 0) and DragDetect(FMouseDownPos) then
	begin
		FMouseDownPos.X := 0;

		if Supports(Model, IDirectory) and (ItemCount > 0) then
		begin
			try
				DataObject := CreateFileListDataObject(Model.Path.Directory,
          FilePtrArray2WideFileNameArray(SelectedFiles));

				FDragDropping := True;
				Application.Async;
				try
					DoDragDrop(DataObject, Self, DROPEFFECT_COPY or DROPEFFECT_LINK or DROPEFFECT_MOVE, R)
				finally
					FDragDropping := False;
					Application.RestoreAsync;
				end;
			except
			on EInOutError do ;
			end;
		end;
	end
	else
		inherited;
end;

function TFilerView.SelectedIsRealFiles: Boolean;
var
	I: Integer;
begin
	if Supports(Model, IArchive) then
	begin
		Result := False;
		Exit
	end;

	if SelectCount = 0 then
	begin
		Result := (CaretIndex >= 0) and (FocusedFile.Kind = fkFile)
	end
	else
	begin
		for I := ItemCount - 1 downto 0 do
			if Selected[I] and (Items[I].Kind <> fkFile) then
			begin
				Result := False;
				Exit;
			end;
		Result := True;
	end;
end;

function TFilerView.GetModel: IFolder;
begin
	Result := FModel
end;

procedure TFilerView.WMLightWindows(var Message: TMessage);
begin
	inherited;
	if Message.WParam = LW_NCPAINT then RepaintFrame;
end;

procedure TFilerView.WMEraseBkgnd(var Message: TWMEraseBkgnd);
var
	DC, MaskDC: HDC;
	R: TRect;
	Bitmap: Windows.BITMAP;
	X, Y, PreCount: Integer;
	I: TFilerView;
	Brush: TBrush;
	TransColor: COLORREF;
	Mask: HBITMAP;
begin
	if not (loEraseBkgnd in ViewOptions) then
	begin
		R := ClientRect;
		DC := CreateCompatibleDC(0);
		if FSkin.Background <> 0 then
		begin
			GetObjectW(FSkin.Background, SizeOf(Bitmap), @Bitmap);
			SelectObject(DC, FSkin.Background);

			PreCount := 0;
			I := Self.FPredView;
			while I <> nil do
			begin
				Inc(PreCount);
				I := I.FPredView;
			end;

			X := - PreCount * (R.Right - R.Left);
			repeat
				Y := 0;
				repeat
					BitBlt(Message.DC, X, Y, Bitmap.bmWidth, Bitmap.bmHeight, DC, 0, 0, SRCCOPY);
					Inc(Y, Bitmap.bmHeight);
				until Succ(Y) >= R.Bottom;
				Inc(X, Bitmap.bmWidth);
			until Succ(X) >= R.Right;
		end
		else
		begin
			Brush := TBrush.Create;
			Brush.Owner := Garbage;
			Brush.Color := FSkin.BackgroundColor;
			FillRect(Message.DC, R, Brush.Handle{GetSysColorBrush(COLOR_WINDOW)});
		end;
		if FSkin.Symbol <> 0 then
		begin
			SelectObject(DC, FSkin.Symbol);
			TransColor := GetPixel(DC, 0, 0);
			//BitBlt(Message.DC, R.Right - 100, R.Bottom - 100, 80, 80, DC, 0, 0, SRCCOPY);
			//TransparentBlt(Message.DC, R.Right - 100, R.Bottom - 100, 80, 80, DC, 0, 0, 80, 80, TransColor);
			Mask := CreateBitmap(80, 80, 1, 1, nil);
			MaskDC := CreateCompatibleDC(DC);
			SetBkColor(DC, TransColor);
			SelectObject(MaskDC, Mask);
			BitBlt(MaskDC, 0, 0, 80, 80, DC, 0, 0, SRCCOPY);
			X := R.Right - 100;
			Y := R.Bottom - 100;
			BitBlt(Message.DC, X, Y, 80, 80, MaskDC, 0, 0, SRCAND);
			BitBlt(Message.DC, X, Y, 80, 80, DC, 0, 0, SRCPAINT);
			DeleteDC(MaskDC);
			DeleteObject(Mask);
		end;
		DeleteDC(DC);
	end;
	Message.Result := 1;
end;

procedure TFilerView.WMAppUpdateSkin(var Message);
var
	Template: PSkinTemplate;
begin
	Template := ApplicationSkinTemplate;

	if FSkin.Background = 0 then
		FSkin.Background := LoadImage(Template^.Background);

	if FSkin.Info = 0 then
		FSkin.Info := LoadImage(Template^.Info);

	if Supports(Model, INameSpace) then
	begin
		if FSkin.NameSpace = 0 then FSkin.NameSpace := LoadImage(Template^.NameSpace);
		FSkin.Symbol := FSkin.NameSpace;
	end
	else if Supports(Model, IFounds) then
	begin
		if FSkin.Founds = 0 then FSkin.Founds := LoadImage(Template^.Founds);
		FSkin.Symbol := FSkin.Founds;
	end
	else if Supports(Model, IArchive) then
	begin
		if FSkin.Archive = 0 then FSkin.Archive := LoadImage(Template^.Archive);
		FSkin.Symbol := FSkin.Archive;
	end
	else
		FSkin.Symbol := 0;

	FSkin.BackgroundColor := Template^.BackgroundColor;
	FSkin.FileName := Template^.FileName;
	FSkin.SystemFile := Template^.SystemFile;
	FSkin.Hidden := Template^.Hidden;
	FSkin.ReadOnly := Template^.ReadOnly;
	FSkin.Directory := Template^.Directory;
	FSkin.Virtual := Template^.Virtual;
	FSkin.Selected := Template^.Selected;
	FSkin.Line := Template^.Line;
	FSkin.InfoText := Template^.InfoText;
	FSkin.SelectedInfoText := Template^.SelectedInfoText;

	Color := RGBColor(FSkin.BackgroundColor);
	if (FSkin.Background = 0) and (FSkin.Symbol = 0) then
		ViewOptions := ViewOptions + [loEraseBkgnd]
	else
		ViewOptions := ViewOptions - [loEraseBkgnd];

	FPen.Color := FSkin.Line
end;

procedure TFilerView.WMLButtonDblClk(var Message: TWMLButtonDblClk);
var
	Action: IAction;
begin
	Action := HostWindow.KeyManager.FindAction(GetShiftState, VK_LBUTTON);
	if (Action = nil) or not Action.Execute then Beep;
end;

procedure TFilerView.WMMButtonUp(var Message: TWMMButtonUp);
var
	Action: IAction;
begin
	Action := HostWindow.KeyManager.FindAction(GetShiftState, VK_MBUTTON);
	if (Action = nil) or not Action.Execute then Beep;
end;

function TFilerView.GetCountOfViewItem: Integer;
begin
	Result := ItemCount
end;

function TFilerView.GetViewSelectedOfViewItem(AIndex: Integer): Boolean;
begin
	Result := Selected[AIndex]
end;

function TFilerView.GetSelectedCountOfViewItem: Integer;
begin
	Result := SelectCount
end;

procedure TFilerView.WMAppOpenView(var Message: TMessage);
var
	P: PPath;
begin
	P := PPath(Message.LParam);
	OpenView(Self, P^);
	FinalizePath(P^);
	Dispose(P);
end;

procedure TFilerView.CloseOnDelay;
begin
	PostMessageW(WM_APP_CLOSEVIEW, 0, 0)
end;

procedure TFilerView.WMAppCloseView(var Message: TMessage);
begin
	if HostWindow.ViewCount > 1 then
		Free
end;

{ TFilerWindow }

constructor TFilerWindow.Create(FirstPath: PPath);
begin
	FFirstPath := FirstPath;
	inherited Create('', DefaultPoint, DefaultSize)
end;

function TFilerWindow.EnumerateViews(Proc: CEachFilerView; Context: Pointer): TFilerView;
begin
	Result := FFirstView;
	while Result <> nil do
	begin
		if Proc(Result, Context) then Exit;
		Result := Result.FSuccView;
	end;
end;

function TFilerWindow.EnumerateViews(Proc: CEachView; Context: Pointer): IView;
var
	I: TFilerView;
begin
	I := FFirstView;
	while I <> nil do
	begin
		Result := I;
		if Proc(Result, Context) then	Exit;
		I := I.FSuccView;
	end;
	Result := nil;
end;

procedure TFilerWindow.Finalize;
begin
	inherited;
	InterlockedDecrement(_FilerWindowCount);
end;

procedure TFilerWindow.FocusChanged;
var
	C: T0Window;
begin
	inherited;

	C := ActiveControl;
	if (C is TFilerView) and Visible and (C <> ActiveView) then
	begin
		if FActiveView <> nil then
			FActiveView.RepaintFrame;

		FActiveView := TFilerView(C);
		FActiveView.RepaintFrame;

		PostMessageW(WM_APP_REALIGN, 0, 0);
	end;
end;

function TFilerWindow.GetKeyManager: IKeyManager;
begin
	Result := FKeyManager
end;

procedure TFilerWindow.Initialize;
var
	F: TFont;
	StartFolder: IFolder;
	M: TMainMenu;
{$IFDEF FOLDERMANAGER_NOSYNC}
	S: Integer;
{$ENDIF}
begin
	inherited;

	{Menu}

	M := TMainMenu.Create;
	M.Owner := Self;
	Menu := M;

	{Key}

	FKeyManager := TKeyAssignment.Create;
	FKeyManager.Owner := Self;

	{Font}

	F := TFont.Create;
	F.Owner := Garbage;

	F.FaceName := 'MS SVbN';
	F.CharSet := DEFAULT_CHARSET;
	F.Size := 9;
	F.Pitch := FIXED_PITCH;

	Font := F;

	{Status Bar}

	FStatusBar := TStatusBar.Create(Self);

	FSpaceStatus := TStatusPane.Create(FStatusBar, nil);
	FSpaceStatus.Alignment := alRight;

	FViewsStatus := TStatusPane.Create(FStatusBar, nil);
	FViewsStatus.Alignment := alCenter;

	//TLockedKeyStatusPane.Create(FStatusBar, nil);

	{View}

{$IFDEF FOLDERMANAGER_NOSYNC}
	S := Application.BeginUpdate;
	try
{$ENDIF}
		StartFolder := (Application as IFolderManager).GetFolder(FFirstPath^);
{$IFDEF FOLDERMANAGER_NOSYNC}
	finally
		Application.EndUpdate(S);
	end;
{$ENDIF}

	TFilerView.Create(Self, nil, StartFolder);

	ActiveControl := FFirstView;
	FActiveView := FFirstView;

	{Size}
	ClientSize := Size(FFirstView.BoundsSize.CX, ClientSize.CY);

	{Layout}
	PostMessageW(WM_APP_REALIGN, 0, 0);

	{Count}
	InterlockedIncrement(_FilerWindowCount);
end;

function TFilerWindow.ReadyHint: WideString;
var
	P: PFile;
begin
	if opInMenuLoop in Operating then
	begin
		Result := '';
		if SelectedMenuItem is TActionMenuItem then
			Result := TActionMenuItem(SelectedMenuItem).Action.Hint
	end
	else
	begin
		P := nil;
		if FActiveView.ItemCount > 0 then P := FActiveView.FocusedFile;
		Result := FActiveView.Model.GetInfoText(P)
	end
end;

procedure TFilerWindow.Realign;
var
	AR: TRect;
	C: TSize;
	NeedW, I, N, H, W, L, R: Integer;
	V: TFilerView;
begin
	inherited;

	if FFirstView <> nil then
	begin
		C := ClientSize;

		H := C.CY - FStatusBar.BoundsSize.CY;
		W := FFirstView.BoundsSize.CX;

		NeedW := FViewCount * W;
		if NeedW < C.CX then
		begin
			C.CX := NeedW;
			ClientSize := C;
			Exit; {WM_SIZE邩獡͉Ȃ}
		end;

		AR := FActiveView.BoundsRect;
		if AR.Left < 0 then
			L := 0
		else if AR.Right > C.CX then
			L := C.CX - W
		else
			L := AR.Left;

		N := 0;
		V := FFirstView;
		while V <> nil do
		begin
			if V = FActiveView then Break;
			Inc(N);
			V := V.FSuccView;
		end;

		if L - N * W > 0 then
			L := N * W;

		R := L + (FViewCount - N) * W; //FLastView.BoundsRect.Right;
		if R < C.CX then
			Inc(L, C.CX - R);

		I := 0;
		V := FFirstView;
		while V <> nil do
		begin
			V.SetBounds((I - N) * W + L, 0, W, H);
			Inc(I);
			V := V.FSuccView;
		end;
	end
end;

procedure TFilerWindow.Update;

	function Fmt(const S: WideString; Value: Int64): WideString;
	begin
		if Value >= 1024 * 1024 * 1024 then
			Result := WideFormat(S, [Value div (1024 * 1024 * 1024), 'G'])
		else if Value >= 1024 * 1024 then
			Result := WideFormat(S, [Value div (1024 * 1024), 'M'])
		else if Value >= 1024 then
			Result := WideFormat(S, [Value div 1024, 'K'])
		else
			Result := WideFormat(S, [Value, ''])
	end;

label
	AD, DF;
var
	Space: Int64;
	I: Integer;
	P: PFile;
	E: UINT;
begin
	if Supports(FActiveView.Model, IDirectory) then
	begin
		if FActiveView.SelectCount > 0 then
		begin
			Space := 0;
			for I := FActiveView.ItemCount - 1 downto 0 do
				if FActiveView.Selected[I] then
				begin
					P := FActiveView.Items[I];
					if P.Attributes and faDirectory <> 0 then goto DF;
					Inc(Space, FActiveView.Items[I].Size);
				end;
			FSpaceStatus.Text := Fmt('Selected: %d%s', Space);
			goto AD;
		end;
DF:
		E := SetErrorMode(SEM_FAILCRITICALERRORS);
		Space := GetDiskFree(FActiveView.Model.Path.Directory);
		SetErrorMode(E);
		if Space >= 0 then
			FSpaceStatus.Text := Fmt('Free: %d%s', Space)
		else
			FSpaceStatus.Text := 'Free: N/A';
AD:
		FSpaceStatus.AdjustSize;
	end
	else
		FSpaceStatus.Width := 0;

	inherited Update;
end;

procedure TFilerWindow.UpdateStatusBar;
const
	W: array[Boolean] of WideString = ('', '');
var
	S: WideString;
	V: TFilerView;
begin
	S := '';
	V := FFirstView;
	while V <> nil do
	begin
		S := S + W[V = FActiveView];
		V := V.FSuccView;
	end;

	FViewsStatus.Text := S;
	FViewsStatus.AdjustSize;
end;

class function TFilerWindow.WindowClassName: string;
begin
	Result := FilerWindowClassName;
end;

procedure TFilerWindow.WMActivate(var Message: TWMActivate);
begin
	inherited;

	EnableIme(Handle, Message.Active = 0);
	ActiveView.RepaintFrame;
end;

procedure TFilerWindow.WMAppRealign(var Message);
var
	M: MSG;
begin
	if PeekMessageW(M, Handle, WM_APP_REALIGN, WM_APP_REALIGN, PM_NOREMOVE) then
		Exit;

	Realign;
	UpdateStatusBar;
	Text := FActiveView.Model.DisplayText;
end;

procedure TFilerWindow.WMAppSetFocus(var Message: TMessage);
begin
	Foreground;
	Windows.SetFocus(Message.WParam);
end;

procedure TFilerWindow.WMCopyData(var Message: TWMCopyData);
begin
	case Message.CopyDataStruct.dwData of
	CmdLineMagicNumber:
		Message.Result := TApplication(Application).ExecuteCommandLine(Message.CopyDataStruct^.lpData);
	else
		inherited
	end
end;

procedure TFilerWindow.WMDrawItem(var Message: TWMDrawItem);
begin
	ProcessDrawItemXP(Message{, BoundsSize.cx - 4});
end;

procedure TFilerWindow.WMGetMinMaxInfo(var Message: TWMGetMinMaxInfo);
var
	A, C: TSize;
begin
	inherited;
	if FFirstView <> nil then
	begin
		A := BoundsSize;
		C := ClientSize;
		if C.CX <> 0 then
		begin
			with Message.MinMaxInfo.ptMinTrackSize do
			begin
				X := FFirstView.BoundsSize.CX + A.CX - C.CX;
				Y := FFirstView.FFontSize.CY * 8 + 9 + A.CY - C.CY + FStatusBar.BoundsSize.CY;
			end;
			Message.MinMaxInfo.ptMaxTrackSize.
				X := FFirstView.BoundsSize.CX * ViewCount + A.CX - C.CX;
			Message.MinMaxInfo.ptMaxSize.Y := GetSystemMetrics(SM_CYMAXIMIZED);
			Message.MinMaxInfo.ptMaxSize.X := Message.MinMaxInfo.ptMaxTrackSize.X;
		end;
	end
end;

procedure TFilerWindow.WMMeasureItem(var Message: TWMMeasureItem);
begin
	ProcessMeasureItemXP(Message);
end;

procedure TFilerWindow.WMMenuChar(var Message: TWMMenuChar);
begin
	ProcessMenuCharXP(Message);
end;

procedure TFilerWindow.WMSize(var Message: TWMSize);
var
	R, W: Integer;
begin
	if (Message.SizeType in [SIZE_MAXIMIZED, SIZE_RESTORED]) and
					(FLastView <> nil) then
	begin
		W := ClientSize.CX;
		R := FLastView.BoundsRect.Right;
		if R < W then
			FActiveView.Position := Point(FActiveView.Position.X + (W - R), 0)
	end;

	inherited;
end;

end.
